<?php
/**
 * Custom template tags for this theme
 *
 * Eventually, some of the functionality here could be replaced by core features.
 *
 * @package Nostalgic Blog
 */

if ( ! function_exists( 'nostalgic_blog_posted_on' ) ) :
	/**
	 * Prints HTML with meta information for the current post-date/time.
	 */
	function nostalgic_blog_posted_on() {
		if ( get_theme_mod( 'nostalgic_blog_post_hide_date', false ) ) {
			return;
		}

		// Get the separate date components for the published date
		$published_month = esc_html( get_the_date( 'F' ) );
		$published_day   = esc_html( get_the_date( 'j' ) );
		$published_year  = esc_html( get_the_date( 'Y' ) );

		// Default time string with separate divs for published date.
		$time_string = '<time class="entry-date published updated" datetime="%1$s">' .
		'<span class="date-wrap">' .
		'<span class="month">%2$s</span>' .
		'<span class="day">%3$s</span>' .
		'<span class="year">%4$s</span>' .
		'</span>' .
		'</time>';

		// Check if the post has been modified.
		if ( get_the_time( 'U' ) !== get_the_modified_time( 'U' ) ) {
			// Get the separate date components for the modified date.
			$modified_month = esc_html( get_the_modified_date( 'F' ) );
			$modified_day   = esc_html( get_the_modified_date( 'j' ) );
			$modified_year  = esc_html( get_the_modified_date( 'Y' ) );

			$time_string = '<time class="entry-date published" datetime="%1$s">' .
			'<span class="date-wrap">' .
			'<span class="month">%2$s</span>' .
			'<span class="day">%3$s</span>' .
			'<span class="year">%4$s</span>' .
			'</span>' .
			'</time>' .
			'<time class="updated" datetime="%5$s">' .
			'<span class="date-wrap">' .
			'<span class="month">%6$s</span>' .
			'<span class="day">%7$s</span>' .
			'<span class="year">%8$s</span>' .
			'</span>' .
			'</time>';
		}

		// Fill the time string with actual date values
		$time_string = sprintf(
			$time_string,
			esc_attr( get_the_date( DATE_W3C ) ),
			$published_month,
			$published_day,
			$published_year,
			esc_attr( get_the_modified_date( DATE_W3C ) ),
			isset( $modified_month ) ? $modified_month : '',
			isset( $modified_day ) ? $modified_day : '',
			isset( $modified_year ) ? $modified_year : ''
		);

		// Create the posted on string with the icon and link to the post
		$posted_on = '<a href="' . esc_url( get_permalink() ) . '">' . $time_string . '</a>';

		// Output the final HTML
		echo '<span class="post-date">' . $posted_on . '</span>'; // phpcs:ignore WordPress.Security.EscapeOutput.OutputNotEscaped
	}
endif;

if ( ! function_exists( 'nostalgic_blog_posted_by' ) ) :
	/**
	 * Prints HTML with meta information for the current author.
	 */
	function nostalgic_blog_posted_by() {
		$byline = sprintf(
		/* translators: %s: post author. */
			'<i class="far fa-user"></i><a class="url fn n" href="' . esc_url( get_author_posts_url( get_the_author_meta( 'ID' ) ) ) . '">' . esc_html( get_the_author() ) . '</a>'
		);

		echo '<span class="byline"> ' . $byline . '</span>'; // phpcs:ignore WordPress.Security.EscapeOutput.OutputNotEscaped

	}
endif;


if ( ! function_exists( 'nostalgic_blog_categories_list' ) ) :
		/**
		 * Prints HTML with meta information for the categories.
		 */
	function nostalgic_blog_categories_list( $with_background = false ) {
		if ( 'post' === get_post_type() ) {

			/* translators: used between list items, there is a space after the comma */
			$categories_list = get_the_category_list( esc_html__( ', ', 'nostalgic-blog' ) );
			if ( $categories_list ) {
				/* translators: 1: list of categories. */
				printf( '<span class="cat-links">' . esc_html__( 'Posted in %1$s', 'nostalgic-blog' ) . '</span>', $categories_list ); // phpcs:ignore WordPress.Security.EscapeOutput.OutputNotEscaped
			}
		}
	}
endif;

if ( ! function_exists( 'nostalgic_blog_entry_footer' ) ) :
	/**
	 * Prints HTML with meta information for the categories, tags and comments.
	 */
	function nostalgic_blog_entry_footer() {
		// Hide category and tag text for pages.
		if ( 'post' === get_post_type() ) {

			/* translators: used between list items, there is a space after the comma */
			$tags_list = get_the_tag_list( '', esc_html_x( ', ', 'list item separator', 'nostalgic-blog' ) );
			if ( $tags_list ) {
					/* translators: 1: list of tags. */
				printf( '<span class="tags-links">' . esc_html__( 'Tagged %1$s', 'nostalgic-blog' ) . '</span>', $tags_list ); // phpcs:ignore WordPress.Security.EscapeOutput.OutputNotEscaped
			}
		}

		if ( ! is_single() && ! post_password_required() && ( comments_open() || get_comments_number() ) ) {
			echo '<span class="comments-link">';
			comments_popup_link(
				sprintf(
					wp_kses(
					/* translators: %s: post title */
						__( 'Leave a Comment<span class="screen-reader-text"> on %s</span>', 'nostalgic-blog' ),
						array(
							'span' => array(
								'class' => array(),
							),
						)
					),
					wp_kses_post( get_the_title() )
				)
			);
			echo '</span>';
		}

		edit_post_link(
			sprintf(
				wp_kses(
				/* translators: %s: Name of current post. Only visible to screen readers */
					__( 'Edit <span class="screen-reader-text">%s</span>', 'nostalgic-blog' ),
					array(
						'span' => array(
							'class' => array(),
						),
					)
				),
				wp_kses_post( get_the_title() )
			),
			'<span class="edit-link">',
			'</span>'
		);
	}
endif;

if ( ! function_exists( 'nostalgic_blog_post_thumbnail' ) ) :
	/**
	 * Displays an optional post thumbnail.

	 * Wraps the post thumbnail in an anchor element on index views, or a div
	 * element when on single views.
	 */
	function nostalgic_blog_post_thumbnail() {
		if ( post_password_required() || is_attachment() || ! has_post_thumbnail() ) {
			return;
		}

		if ( is_singular() ) :
			?>

		<div class="post-thumbnail">
			<?php the_post_thumbnail(); ?>
		</div><!-- .post-thumbnail -->

		<?php else : ?>

			<a class="post-thumbnail" href="<?php the_permalink(); ?>" aria-hidden="true" tabindex="-1">
				<?php
				the_post_thumbnail(
					'post-thumbnail',
					array(
						'alt' => the_title_attribute(
							array(
								'echo' => false,
							)
						),
					)
				);
				?>
			</a>

			<?php
	endif; // End is_singular().
	}
endif;

if ( ! function_exists( 'wp_body_open' ) ) :
	/**
	 * Shim for sites older than 5.2.

	 * @link https://core.trac.wordpress.org/ticket/12563
	 */
	function wp_body_open() {
		do_action( 'wp_body_open' );
	}
endif;
